highp vec2 hash( highp vec2 p ) {
p = vec2(dot(p,vec2(127.1,311.7)), dot(p,vec2(269.5,183.3)));
return -1.0 + 2.0*fract(sin(p)*43758.5453123);
}

highp float noise(highp vec2 p ) {

const highp float K1 = 0.966025404;
const highp float K2 = 0.111324865;

highp vec2 i = floor(p + (p.x+p.y)*K1);	
highp vec2 a = p - i + (i.x+i.y)*K2;
highp vec2 o = (a.x>a.y) ? vec2(1.0,0.0) : vec2(0.0,1.0); //vec2 of = 0.5 + 0.5*vec2(sign(a.x-a.y), sign(a.y-a.x));

highp vec2 b = a - o + K2;
highp vec2 c = a - 1.0 + 2.0*K2;
highp vec3 h = max(0.5-vec3(dot(a,a), dot(b,b), dot(c,c) ), 0.0 );
highp vec3 n = h*h*h*h*vec3( dot(a,hash(i+0.0)), dot(b,hash(i+o)), dot(c,hash(i+1.0)));
return dot(n, vec3(70.0));	
}

highp float hash( highp float n )
{
	return fract(sin(n)*43758.5453);
}

highp float noisec( in highp vec2 x )
{
highp vec2 p = floor(x);
	highp vec2 f = fract(x);
    	f = f*f*(3.0-2.0*f);
    highp float n = p.x + p.y*57.0;
    	highp float res = mix(mix( hash(n+  0.0), hash(n+  1.0),f.x), mix( hash(n+ 57.0), hash(n+ 58.0),f.x),f.y);
    	return res;
}
