void watercolor(inout vec4 set){
if(ccolor.b > 0.6 && ccolor.g > 0.2){

                 float day_f = pow(max(min(1.0-FOG_COLOR.b * 1.2, 1.0), 0.0), 0.5);
                 float night_f = pow(max(min(1.0-FOG_COLOR.r * 1.5, 1.0), 0.0), 1.2);
                 float rain_f = (1.0 - pow(FOG_CONTROL.y, 11.0));

                 vec4 day = vec4(0.35,0.4,0.5,0.25);                 
                 vec4 night = vec4(FOG_COLOR.rgb,0.2);                 
                 vec4 dusk = vec4(0.08,0.0,0.1,0.1)*1.7;                
                 vec4 rain = vec4(FOG_COLOR.rgb,0.2);                                    
                 
                  vec4 water_color = mix(mix(mix(day,dusk,day_f), night, night_f),rain,rain_f);
                                  
                 set = vec4(water_color);
                             
set *= mix(vec4(vec3(1.0),1.0), vec4(vec3(0.5),10.0), smoothstep(0.0, 1.0, length(worldpos.xz) / RENDER_DISTANCE));}
}
